/*
 * Cell.cpp
 *
 *  Created on: Feb 14, 2015
 *      Author: rmin
 */

#include "Cell.h"
#include <chrono>

Cell::Cell(EventHandler* eventHandler, DynamicData &dynamicData) {
	this->eventHandler = eventHandler;
	mId = dynamicData.getId();
	mPos = dynamicData.getPosition();
	mTeamId = dynamicData.getOther()["teamId"].asInt();
	mEnergy = dynamicData.getOther()["energy"].asInt();
}

Cell::Cell(std::string id, Position pos, int teamId, int energy) {
	eventHandler = NULL;
	mId = id;
	mPos = pos;
	mTeamId = teamId;
	mEnergy = energy;
}

void Cell::move(Direction direction) {
	GameEvent* event = new GameEvent(GameEvent::TYPE_MOVE);
	event->setObjectId(mId);
	event->addArg(DirectionStr[direction]);

	eventHandler->addEvent(event);
}

void Cell::gainResource() {
	GameEvent *event = new GameEvent(GameEvent::TYPE_GAIN_RESOURCE);
	event->setObjectId(mId);

	eventHandler->addEvent(event);
}

void Cell::mitosis() {
	GameEvent *event = new GameEvent(GameEvent::TYPE_MITOSIS);
	event->setObjectId(mId);

	eventHandler->addEvent(event);
}

std::string Cell::getId() {
	return mId;
}

Position Cell::getPos() {
	return mPos;
}

int Cell::getTeamId() {
	return mTeamId;
}

int Cell::getEnergy() {
	return mEnergy;
}

Cell::~Cell() {
	// TODO Auto-generated destructor stub
}

