/*
 * Controller.h
 *
 *  Created on: Feb 3, 2015
 *      Author: rmin
 */

#ifndef CONTROLLER_H_
#define CONTROLLER_H_

#include <ctime>

#include <boost/array.hpp>
#include <boost/thread.hpp>
#include <boost/chrono.hpp>
#include <boost/bind.hpp>

#include "Message.h"
#include "Network.h"
#include "AI.h"
#include "Model.h"
#include <fstream>
#include <string>
#include "EventHandler.h"

const long int MAX_TIME_FOR_DO_TURN = 400;

class Controller {
private:
	std::string token,ip;
	int port;
	EventHandler *eventHandler;
	AI* client;
	Model* model;
	Network* network;
	std::string settingsFile;
	time_t time;
	void handleTurnMessage(Message &msg);
	void handleInitMessage(Message &msg);
	Message getEvents();
	void doTurn();
	void run();
public:
	void handleMessage(Message &msg);
	Controller(std::string settingsFile);
	void start();
	void readClientData();
	virtual ~Controller();
};

#endif /* CONTROLLER_H_ */
