/*
 * Network.h
 *
 *  Created on: Feb 4, 2015
 *      Author: rmin
 */

#ifndef NETWORK_H_
#define NETWORK_H_

#define MAX_LEN_OF_TCP 66000

#include "Message.h"
#include <vector>

#include <boost/array.hpp>
#include <vector>
#include <boost/asio.hpp>
#include "SubPacket.h"

using boost::asio::ip::tcp;

class Network {
	std::vector<SubPacket*> Packet;
	bool isTerminated;
	std::string port;
	std::string host;
	std::string token;
	bool isConnected;
	boost::asio::io_service *io_service;
	tcp::resolver *resolver;
	tcp::resolver::query *query;
	tcp::resolver::iterator endpoint_iterator;
	tcp::socket *socket;
	bool doReceive();
	void startReceiving();
	void* controllerVoid;
public:
	Network(void* controller);
	void send(Message msg);
	void parse();
	void terminate();
	void setConnectionData(std::string host,int port,std::string token);
	void connect();
	virtual ~Network();
	bool getIsConnected();
	bool getIsTerminated();
	void clearPacket();
};

#endif /* NETWORK_H_ */
