/*
 * Parser.cpp
 *
 *  Created on: Feb 15, 2015
 *      Author: rmin
 */

#include "Parser.h"

Parser::Parser() {
	// TODO Auto-generated constructor stub

}

Parser::~Parser() {
	// TODO Auto-generated destructor stub
}

void Parser::parsStaticData(Json::Value &msg, StaticData &staticData) {
	staticData.setId(msg["id"].asString());

	staticData.setType(msg["type"].asString());

	staticData.setTurn(msg["turn"].asInt());

	staticData.setPosition(
			Position(msg["position"]["x"].asInt(),
					msg["position"]["y"].asInt()));

	staticData.setOther(msg["other"]);
}

void Parser::parsDynamicData(Json::Value &msg, DynamicData &dynamicData) {
	dynamicData.setId(msg["id"].asString());

	dynamicData.setType(msg["type"].asString());

	dynamicData.setPosition(
			Position(msg["position"]["x"].asInt(),
					msg["position"]["y"].asInt()));

	dynamicData.setOther(msg["other"]);
}

void Parser::parsClientInitInfo(Json::Value &msg,
		ClientInitInfo &clientInitInfo) {
	clientInitInfo.setTurn(msg["turn"].asInt());

	Json::Value tmp = msg["teams"];

	for (int i = 0; i < (int) tmp.size(); i++) {
		clientInitInfo.addTeam(tmp[i].asString());
	}

	clientInitInfo.setYourInfo(
			TeamInfo(msg["yourInfo"]["name"].asString(),
					msg["yourInfo"]["id"].asInt()));

	clientInitInfo.setMapSize(
			MapSize(msg["mapSize"]["width"].asInt(),
					msg["mapSize"]["height"].asInt()));

}

void Parser::generateEvent(Message &msg, GameEvent &event) {
	msg.addNode("type", event.getType());
	msg.addNode("objectId", event.getObjectId());
	std::vector<std::string> args;
	for (int i = 0; i < (int) event.getArgs().size(); i++) {
		args.push_back(event.getArgs()[i]);
	}
	msg.addArray("args", args);
}
